Bug 1109364 - valgrind - value mem leaks, uninit mem usage
Summary: valgrind - value mem leaks, uninit mem usage
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: 389-ds-base
Version: 7.1
Hardware: Unspecified
OS: Unspecified
low
unspecified
Target Milestone: rc
: ---
Assignee: Noriko Hosoi
QA Contact: Viktor Ashirov
URL:
Whiteboard:
Depends On: 1109363
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-06-13 18:25 UTC by Noriko Hosoi
Modified: 2015-03-05 09:35 UTC (History)
3 users (show)

Fixed In Version: 389-ds-base-1.3.3.1-1.el7
Doc Type: Bug Fix
Doc Text:
Cause: The caller of an API slapi_valueset_add_attr_valuearray_ext was supposed to free the returned Slapi_ValueSet upon failure, but it was not done properly. Consequence: The Slapi_ValueSet was leaked when adding an attribute failed. Fix: The code to free the memory is added. Result: The returned Slapi_ValueSet does not get leaked.
Clone Of: 1109363
Environment:
Last Closed: 2015-03-05 09:35:27 UTC
Target Upstream Version:


Attachments (Terms of Use)
valgrind output (65.57 KB, text/plain)
2015-01-09 16:05 UTC, Viktor Ashirov
no flags Details


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2015:0416 normal SHIPPED_LIVE Important: 389-ds-base security, bug fix, and enhancement update 2015-03-05 14:26:33 UTC

Description Noriko Hosoi 2014-06-13 18:25:29 UTC
+++ This bug was initially created as a clone of Bug #1109363 +++

This bug is created as a clone of upstream ticket:
https://fedorahosted.org/389/ticket/47455

This breaks slapi-nis.
https://git.fedorahosted.org/cgit/slapi-nis.git/tree/src/back-sch.c#n581

dn: cn=ng1,cn=ng,cn=compat,cn=accounts,dc=example,dc=com
objectClass: nisNetgroup
memberNisNetgroup: ng2
memberNisNetgroup: ng3
memberNisNetgroup: ng3

becomes

dn: cn=ng1,cn=ng,cn=compat,cn=accounts,dc=example,dc=com
objectClass: nisNetgroup
memberNisNetgroup: ng3

but it should be
dn: cn=ng1,cn=ng,cn=compat,cn=accounts,dc=example,dc=com
objectClass: nisNetgroup
memberNisNetgroup: ng2
memberNisNetgroup: ng3

That is, slapi_str2entry should just throw out the duplicate ng3 value and keep the ng2 value

Comment 1 Noriko Hosoi 2014-06-17 21:10:04 UTC
Steps to verify:
https://bugzilla.redhat.com/show_bug.cgi?id=1109363#c1

Comment 3 Viktor Ashirov 2015-01-09 16:05:28 UTC
Created attachment 978256 [details]
valgrind output

$ rpm -qa | grep 389-ds
389-ds-base-debuginfo-1.3.3.1-11.el7.x86_64
389-ds-base-1.3.3.1-11.el7.x86_64
389-ds-base-libs-1.3.3.1-11.el7.x86_64

Uniqueness plugin is enabled:
$ ldapsearch -LLL -D "cn=Directory Manager" -w Secret123 -b "cn=attribute uniqueness,cn=plugins,cn=config" nsslapd-pluginEnabled
dn: cn=attribute uniqueness,cn=plugins,cn=config
nsslapd-pluginEnabled: on

[1] Adding an entry that breaks the attribute uniqueness:
$ ldapmodify -D "cn=Directory Manager" -w Secret123 -a << EOF
dn: cn=ng1,ou=groups,dc=example,dc=com
objectClass: nisNetgroup
memberNisNetgroup: ng2
memberNisNetgroup: ng3
memberNisNetgroup: ng3
EOF
adding new entry "cn=ng1,ou=groups,dc=example,dc=com"
ldap_add: Type or value exists (20)

[2] Adding an entry that doesn't break attribute uniqueness:
$ ldapmodify -D "cn=Directory Manager" -w Secret123 -a << EOF
dn: cn=ng1,ou=groups,dc=example,dc=com
objectClass: nisNetgroup
memberNisNetgroup: ng2
memberNisNetgroup: ng3
EOF
adding new entry "cn=ng1,ou=groups,dc=example,dc=com"

$ sudo /usr/sbin/stop-dirsrv 
Stopping instance "rhel7ds"

$ grep slapi_valueset_add_attr_valuearray_ext /tmp/valgrind-20150109-165422-rhel7ds.out | wc -l
0

Marking as VERIFIED

Comment 5 errata-xmlrpc 2015-03-05 09:35:27 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2015-0416.html


Note You need to log in before you can comment on or make changes to this bug.